%% paper.lhs
%% Copyright (C) 2006 by Conal Elliott
%% Created: Wed Apr 19, 2006 13:17
%% Last Modified: Sun Jul 29, 2007 22:30 by Conal Elliott

\documentclass[preprint,nocopyrightspace]{sigplanconf}

% I don't like links while drafting, since they result in a bookmarks pane
% in Acrobat Reader.  Turn off "draft" later.
\usepackage[colorlinks,urlcolor=black,draft=true]{hyperref}

%% \conferenceinfo{2006 Haskell Workshop}{Portland} 
%% \copyrightyear{2006} 
%% \copyrightdata{[to be supplied]} 

% Ignored unless 'preprint' option specified.
%\preprintfooter{For submission to the 2006 Haskell Workshop}
\titlebanner{DRAFT---Comments please}

\input{macros}

%include polycode.fmt
%include forall.fmt
%include format.fmt

%% \title{Phooey -- A Simple, Functional, Arrow-Based \\Library for User Interfaces}

%% \title{Imperative GUIs?  Phooey!\\[2ex]Simple, Functional Approaches to GUI Programming}
%% \title{Applicative GUI Programming}
%% \title{Applicative Programming for\\ Data-Driven Computation}
\title{Applicative Data-Driven Computation}
%% \title{Applicative User Interfaces}

%% \date\today
%% \author{Conal Elliott}

\authorinfo{Conal Elliott}{LambdaPix}{conal@@conal.net}

\begin{document}

\maketitle

\begin{abstract}

Graphical user interfaces (GUIs) are usually programmed in an ``unnatural'' style, in that implementation dependencies are inverted, relative to logical dependencies.
We suggest that this reversal results directly from the imperative, data-driven orientation of most GUI libraries.
While outputs depend on inputs from a user and semantic point of view, the data-driven approach imposes an implementation dependence of inputs on outputs.

This paper presents simple, functional interfaces for data-driven programming in general and GUI programming in particular, in which program dependencies directly mirror logical dependencies.
The interfaces are structured as \emph{applicative functors (AFs)}, rather than monads or arrows.
Efficiency is retained while abstracting the mechanics of data-driven computation out of client  programs and into reusable library code.
The implementations of data-driven computation and of GUIs are also quite simple, largely due to structuring them as \emph{compositions} of AFs.

This paper is in draft stage.  I'd love to get your comments, especially via the paper's wiki ``talk page'', where you can find other comments as well.\footnote{\talkpage}

\end{abstract}


%include DataDriven.lhs
%include SimpleUI.lhs
%include FlexibleLayout.lhs
%include UniqueNotify.lhs

\bibliographystyle{abbrv}
\bibliography{refs}

\end{document}
